/*
 * fir_filter.c
 *
 *      Author: GSI
 */

#include <usbstk5515.h>
#include <usbstk5515_i2c.h>
#include <AIC_func.h>
#include <stdio.h>
#include "low_pass.h"

#define ASIZE 		61

#define TCR0 		*((ioport volatile Uint16 *)0x1810)
#define TIMCNT1_0 	*((ioport volatile Uint16 *)0x1814)
#define TIME_START  0x8001
#define TIME_STOP   0x8000

Int16 in [ASIZE];
Uint16 delta_time;


Int16 FIR(Uint16 i)
{
	Int32 sum;
	Uint16 j;
	Uint32 index;
	sum=0;

	//The actual filter work
	for(j=0; j<LPL; j++)
	{
		if(i>=j)
 			index = i - j;
		else 
 			index = ASIZE + i - j;
		sum += (Int32)in[index] * (Int32)LP[j];
	}
	sum = sum + 0x00004000;			// So we round rather than truncate.
	return (Int16) (sum >> 15);  	// Conversion from 32 Q30 to 16 Q15.

}


void main(void)
{
	Uint16 i;
	Uint16 start_time;
	Uint16 end_time;
	Int16 right, left; //AIC inputs
	Int16 out;

	USBSTK5515_init(); 	//Initializing the Processor
	AIC_init(); 		//Initializing the Audio Codec
	//Priming the PUMP
	for(i = 0; i < (ASIZE); i++)
	{
		AIC_read2(&right, &left);
		in[i] = right;
	}
	while(1)
	{
		if(i>=ASIZE) i=0;
		AIC_read2(&right, &left);
		in[i] = right;
		out = FIR(i);
		//POSTFILTER:
		AIC_write2(out, out);
		i++;
	}
}
